package com.malk.pake;

import cn.hutool.core.util.NumberUtil;
import com.alibaba.fastjson.JSONObject;
import com.malk.server.aliwork.YDConf;
import com.malk.server.aliwork.YDParam;
import com.malk.service.aliwork.YDClient;
import com.malk.service.dingtalk.DDClient;
import com.malk.service.dingtalk.DDClient_Alibtrip;
import com.malk.utils.PublicUtil;
import com.malk.utils.UtilDateTime;
import com.malk.utils.UtilMap;
import lombok.Data;
import lombok.extern.slf4j.Slf4j;
import netscape.javascript.JSObject;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

import java.time.LocalDate;
import java.time.LocalDateTime;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Slf4j
@SpringBootTest
@RunWith(SpringRunner.class)
public class SlTest {

    @Autowired
    private YDClient ydClient;

    private static List<configDto> config;
    private static List<configDto> config2;

    {
        config=new ArrayList<>();
        // 实际   预算
        config.add(new configDto("numberField_lwswoudr","numberField_lwswouds"));
        config.add(new configDto("numberField_lwswoudt","numberField_lwswoueo"));
        config.add(new configDto("numberField_lwswoue6","numberField_lwswouez"));
        config.add(new configDto("numberField_lwswoue7","numberField_lwswouf0"));
        config.add(new configDto("numberField_lwswoue8","numberField_lwswouf1"));
        config.add(new configDto("numberField_lwswoue9","numberField_lwswouf2"));
        config.add(new configDto("numberField_lwswouea","numberField_lwswouf3"));
        config.add(new configDto("numberField_lwswoueb","numberField_lwswouf5"));
        config.add(new configDto("numberField_lwswouec","numberField_lwswouf7"));
        config.add(new configDto("numberField_lwswoued","numberField_lwswouf9"));
        config.add(new configDto("numberField_lwswouee","numberField_lwswoufb"));
        config.add(new configDto("numberField_lwswouef","numberField_lwswoufd"));

        config2=new ArrayList<>();
        // 类型   金额  一级部门 二级部门
        config2.add(new configDto("100","第三方采购","textField_40lr8u5","textField_qpi47c5","textField_iqu0lt4"));
        config2.add(new configDto("200","代运营保底赔付","textField_4ja4exh","",""));
        config2.add(new configDto("201","代运营保底赔付","textField_4ja4exh","",""));
        config2.add(new configDto("300","内容成本","textField_yskuizk","textField_n6dgais","textField_nywps4o&&textField_cq3wrgw"));
        config2.add(new configDto("400","渠道成本","textField_0p6725u","textField_niydh0v","textField_cq3wrgw"));
        config2.add(new configDto("500","版权赔付","textField_7z9umea","textField_n6dgais","textField_cq3wrgw"));
        config2.add(new configDto("600","项目专线、IDC租赁","textField_o7hrwxq","textField_niydh0v","textField_nywps4o&&textField_cq3wrgw"));
        config2.add(new configDto("700","中标服务费","textField_rl6bu4e","textField_niydh0v","textField_nywps4o"));
        config2.add(new configDto("800","经营性固定资产采购","textField_zkp9rt7","textField_qpi47c5","textField_iqu0lt4"));
        config2.add(new configDto("900","研发设备采购费","textField_f4hxczh","textField_bs5acse","textField_absucq7"));
        config2.add(new configDto("1000","研发软件及服务采购","textField_vh8bd91","textField_r391zwq","textField_4kzpuqt"));
        config2.add(new configDto("1100","投流成本","textField_6fykj0t","textField_pr7mh62","textField_2hpmihn"));
    }

    private class configDto{
        public String id;
        public String key;
        public String key2;
        public String key3;
        public String key4;
        public configDto(String key,String key2){
            this.key=key;
            this.key2=key2;
        }
        public configDto(String id,String key,String key2,String key3,String key4){
            this.id=id;
            this.key=key;
            this.key2=key2;
            this.key3=key3;
            this.key4=key4;
        }
    }

    @Test
    public void test(){
        Map data =ydClient.queryData(YDParam.builder().formInstId("FINST-II966NA1L6ILZK9FEVQUNC9LJZ7K2RN315QWL741").build(), YDConf.FORM_QUERY.retrieve_id).getFormData();
        System.out.println(data);
        LocalDateTime localDateTime= UtilDateTime.getLocalDateTimeFromTimestamp(UtilMap.getLong(data,"dateField_cs14yue"));
        int month=localDateTime.getMonthValue();
        for(configDto configDto:config2){
            String amt=UtilMap.getString(data,configDto.key2);
            syncYida(configDto.id,configDto.key,config.get(month).key,amt,"numberField_lwswoufl");// 实际；预算：numberField_lwswoufm
        }
        System.out.println("处理完成");
    }

    private void syncYida(String id,String type,String amtKey,String amt,String totalKey){
        Map map1=new HashMap();
        map1.put("textField_lwu9zcqh",id);
        map1.put("textField_lwswoudn",type);
        map1.put(amtKey,amt);
        List<Map> list = (List<Map>) ydClient.queryData(YDParam.builder().formUuid("FORM-486A690141BD41E29C47355F79E5137CLTO2")
                .searchFieldJson(JSONObject.toJSONString(UtilMap.map("textField_lwu9zcqh", type))).build(), YDConf.FORM_QUERY.retrieve_list_all).getData();
        if(list==null||list.size()<1){
            map1.put(totalKey,amt);// 汇总
            ydClient.operateData(YDParam.builder()
                    .formUuid("FORM-486A690141BD41E29C47355F79E5137CLTO2")
                    .formDataJson(JSONObject.toJSONString(map1))
                    .build(), YDConf.FORM_OPERATION.create);
        }else{
            Map map=list.get(0);
            Map formData=UtilMap.getMap(map,"formData");
            map.put(amtKey, NumberUtil.add(UtilMap.getString(formData,(amtKey)),amt));
            map.put(totalKey, NumberUtil.add(UtilMap.getString(formData,(totalKey)),amt));
            ydClient.operateData(YDParam.builder().formInstId("FORM-486A690141BD41E29C47355F79E5137CLTO2")
                    .updateFormDataJson(JSONObject.toJSONString(map))
                    .build(), YDConf.FORM_OPERATION.update);
        }
    }



}
